<template>
  <VxeGrid ref="hxPgd" v-bind="gridOptions" @cell-click="cellClick" @current-change="getCurrentData" />
</template>

<script>
import paoWanPgdConfig from './pgdTable'
import {getDw, getPgd, getPgd2, zx} from "@/api/zyjh";
export default {
  name:'HxianPgd',
  props:{
    workers:{
      type:Array,
      default:[]
    },
    dw:{
      type:Array,
      default: []
    }
  },
  data(){
    return{
      gridOptions:{},
      list:{},
      setExt:null,
    }
  },
  sockets:{
    zyjhzx(data){
      if (this.deviceId!==data.msg.deviceId&&data.msg.actionType!=='开始报工'){
        return
      }
      //工单号尾号长度
      const djhWhLengh=3
      const tmpList=this.list.filter(item=>item.djh===data.msg.orderNumber||item.djh.slice(-djhWhLengh)===data.msg.orderNumber)
      if (tmpList.length>1){
        this.list=tmpList
        this.$message.warning('短号有重复,请使用全工单号重新派工!!!')
        return
      }
      for (const item of this.list) {
        if (item.djh===data.msg.orderNumber||item.djh.slice(-djhWhLengh)===data.msg.orderNumber){
          const tmpArr=[{
            id:item.id,
            hxfkry:item.hxry
          }]
          this.baogong(tmpArr,item)
          break
        }
      }
    }
  },
  created(){
    const {options,columns,setExt}=paoWanPgdConfig()
    this.setExt=setExt
    this.gridOptions=options
    this.gridOptions.columns=columns
  },
  methods:{
    baogong(tmpArr,data){
      let ycldwInfo=null
      for (const dw of this.dw) {
        for (const info of dw.list) {
          if (data.dcCh===info.czbh&&data.dcPl===info.pl&&data.dcFd===info.fd&&data.tzbh===info.tlth){
            ycldwInfo=info
            break
          }
        }
      }
      if (!ycldwInfo){
        this.$message.warning(`理料垛位上板材与记录不符,需查验后再进行报工!`)
        return;
      }
      zx({
        field:'hxfkrq',
        zxZtName:'HXFK',
        list:tmpArr,
        ycldwInfo:ycldwInfo
      }).then(res=>{
        if (res.success){
          window.localStorage.removeItem('zyjh')
          this.initData(data.pwry,'51')
        }
      })
    },
    initData(worker,zt){
      getDw({type:'llj'}).then(res=>{
        this.gridOptions.ycldw=res.data
        getPgd({user:worker,zt:zt,field:'hxry'}).then(res=>{
          this.list=res.data
          this.gridOptions.data=res.data
          this.setExt('workers',this.$props.workers)
        })
      })
    },
    getCurrentData(){
      const data= this.$refs.hxPgd.getCurrentRecord()
      window.localStorage.setItem("hxfk",JSON.stringify(data))
    },
    cellClick({row}){
      this.$emit('pgdClick',row)
      this.$emit('initPgd',row)
    }
  }
}
</script>
